#ifndef ROVERBASES_H
#define ROVERBASE_H

#include <stdio.h>

#define PUBLIC			/* Accessible outside this module     */
#define PRIVATE static		/* Accessible only within this module */

#ifndef FREE
#define FREE(x) if (x) {free(x); x=NULL;}
#endif /* FREE */

extern char myAppID[32];
extern int RoverDebug;
extern char *RoverHome;
extern int AbortInProgress;

#if defined(ROVER_CLIENT) || defined(ROVER_ACCESSMGR)
extern void RoverExit(int ex);

#ifdef DEBUG
#define	ASSERT(p)   if (!(p)) botch(#p)
static void botch(char *s)
{
  fprintf(stderr, "\r\nAssertion botched: %s\r\n", s);
  (void) fflush(stderr);		/* just in case user buffered it */
  if (AbortInProgress) {
    fprintf(stderr, "\r\nAssertion botched while aborting!\r\n");
    abort();
  }
  RoverExit(-1);
}
#else
#define	ASSERT(p)
#endif /* DEBUG */
#endif /* defined(ROVER_CLIENT) || defined(ROVER_ACCESSMGR) */

#endif /* ROVERBASES_H */
