<H2>HTSimplify: Simplify a UTL</H2>

A URI is allowed to contain the seqeunce xxx/../ which may be
replaced by "" , and the seqeunce "/./" which may be replaced by "/".
Simplification helps us recognize duplicate URIs. Thus, the following
transformations are done:

<UL>
<LI> /etc/junk/../fred 	becomes	/etc/fred
<LI> /etc/junk/./fred	becomes	/etc/junk/fred
</UL>

but we should NOT change
<UL>
<LI> http://fred.xxx.edu/../.. or
<LI> ../../albert.html
</UL>

In the same manner, the following prefixed are preserved:

<UL>
<LI> ./<etc>
<LI> //<etc>
</UL>

In order to avoid empty URIs the following URIs become:

<UL>
<LI> /fred/..		becomes /fred/..
<LI> /fred/././..		becomes /fred/..
<LI> /fred/.././junk/.././	becomes /fred/..
</UL>

If more than one set of `://' is found (several proxies in cascade) then
only the part after the last `://' is simplified.

<PRE>
extern char *HTSimplify PARAMS((char *filename));
</PRE>


<H2>HTExpand: Expand a Local Host Name Into a Full Domain Name</H2>

This function expands the host name of the URI from a local name to a
full domain name and converts the host name to lower case. The
advantage by doing this is that we only have one entry in the host
case and one entry in the document cache.

<PRE>
extern char *HTCanon PARAMS ((	char **	filename,
				char *	host));
</PRE>

