#ifndef ROVERTYPES_H
#define ROVERTYPES_H

typedef enum _RoverObjType {
  ROVER_BINARY = 1,		/* Application binary */
  ROVER_BINARY_UPDATE,		/* Updated application binary */
  ROVER_TCL,			/* Tcl code */
  ROVER_TCL_UPDATE,		/* Updated tcl code */
  ROVER_TCL_TK,			/* Tcl/tk code */
  ROVER_TCL_TK_UPDATE,		/* Updated tcl/tk code */
  ROVER_ERROR_OBJ,		/* Rover error object */
  ROVER_HTTP,			/* Rover HTTP object */
  ROVER_HTTP_UPDATE,		/* Updated Rover object */
  ROVER_LOG_SUFFIX,		/* Rover Log suffix */
  ROVER_CMD_COMPLETE		/* Rover server command completed */
} RoverObjType;

typedef enum _RoverCacheable {
  ROVER_NO_CACHE = 1,	/* Do not cache */
  ROVER_CACHE_FOREVER,	/* Can be cached forever (immutable) */
  ROVER_VERIFY,		/* Verify object before returning from cache */
  ROVER_VERIFIED,	/* Verification of client's copy of object */
  ROVER_BEST_EFFORT,	/* Periodically check object is up-to-date  */
  ROVER_BE_VERIFIED,	/* Verification of client's copy of object */
  ROVER_CALLBACK,	/* Object registered for server callback [!impld] */
  ROVER_LEASE		/* Object valid for specific time period [!impld] */
} RoverCacheable;

typedef enum _RoverOpStatus {
  OP_COMMIT = 1,	/* Operation committed */
  OP_ABORT		/* Operation aborted */
} RoverOpStatus;

#ifndef VERBOSE
#define ROVER_CMD_SPEC		"C"
#define ROVER_OBJ_SPEC		"O"
#define ROVER_CODE_SPEC		"CD"
#define ROVER_AUTH_SPEC		"A"
#define ROVER_USER_SPEC		"U"
#define ROVER_MSGID_SPEC	"M"
#define ROVER_HOST_SPEC		"H"
#define ROVER_LOGID_SPEC	"L"
#define ROVER_TIME_SPEC		"T"
#define ROVER_SVC_SPEC		"S"
#define ROVER_SVCID_SPEC	"I"
#define ROVER_RETRY_SPEC	"R"
#define ROVER_HTTPD_SPEC	"HH"
#define ROVER_PORT_SPEC		"P"
#define ROVER_INC_SPEC		"I"

#define ROVER_IMPORTBINARY_CMD	"IB"
#define ROVER_IMPORT_CMD	"I"
#define ROVER_IMPORTDATA_CMD	"ID"
#define ROVER_EXPORT_CMD	"E"
#define ROVER_RESET_CMD		"R"
#define ROVER_HTTP_CMD		"H"
#define ROVER_SMTP_CMD		"S"
#define ROVER_TEST_CMD		"T"

#else
#define ROVER_CMD_SPEC		"CMD"
#define ROVER_OBJ_SPEC		"OBJ"
#define ROVER_CODE_SPEC		"CODE"
#define ROVER_AUTH_SPEC		"AUTH"
#define ROVER_USER_SPEC		"USER"
#define ROVER_MSGID_SPEC	"MSGID"
#define ROVER_HOST_SPEC		"RHOST"
#define ROVER_LOGID_SPEC	"LOGID"
#define ROVER_TIME_SPEC		"TIME"
#define ROVER_SVC_SPEC		"SVC"
#define ROVER_SVCID_SPEC	"SVCID"
#define ROVER_RETRY_SPEC	"RETRY"
#define ROVER_HTTPD_SPEC	"HTTPDHOST"
#define ROVER_PORT_SPEC		"PORT"

#define ROVER_IMPORTBINARY_CMD	"IMPORTBINARY"
#define ROVER_IMPORT_CMD	"IMPORT"
#define ROVER_IMPORTDATA_CMD	"IMPORTDATA"
#define ROVER_EXPORT_CMD	"EXPORT"
#define ROVER_RESET_CMD		"RESET"
#define ROVER_HTTP_CMD		"HTTP"
#define ROVER_SMTP_CMD		"SMTP"
#define ROVER_TEST_CMD		"TEST"

#endif /* VERBOSE */

/* Test spec */
#define ROVER_SIZE_SPEC		"SIZE"

#endif /* ROVERTYPES_H */
